//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//

#pragma once

class TorusWindow;															//	forward declaration

#include "TorusMenuBar.h"
#include "TorusView.h"
#include "TorusToolView.h"

BRect defaultTorusWindowRect(40, 40, 600, 460);								//	default size for window

class TorusWindow : public BWindow											//	a window for displaying a torus
	{
	private:
	TorusMenuBar *theMenuBar;												//	pointer to our menu bar
	TorusView *theTorusView;												//	pointer to our main view
	TorusToolView *theTorusToolView;										//	pointer to our tool palette
	Torus *theTorus;														//	pointer to the torus
	BFilePanel *itsSavePanel; 												//	the file panel used for selecting file name
	BMessenger *itsMessenger;												//	the messenger invoked by the file panel
	BMessage *pageSetup;													//	the page setup stored
		
	public:	
	TorusWindow(BRect theFrame, char *theTorusText = NULL, BMessage *theLocation = NULL);
																			//	constructor
	~TorusWindow();															//	destructor
	
	virtual bool QuitRequested();											//	our exit routine
	virtual void MessageReceived(BMessage *theEvent);						//	processes messages
	void ShowSavePanel();													//	shows the save panel for this file
	void SaveAsText(BMessage *theEvent);									//	routine to save a file in text format
	void PageSetup();														//	sets up page for printing
	void Print();															//	prints page
	}; // end of TorusWindow class
																			