//	74.442	Advanced Design & Analysis of Algorithms
//	Spring 1998
//	Dr. Bill Kocay
//
//	Hamish Carr
//	Project:	Toroidal Surface Geometries
//
//

#include "Vector.h"

Vector returnVector;														//	used for passing results
BPoint returnPoint;														

Vector::Vector()															//	default constructor
	{
	} // end of Vector default constructor

Vector::Vector(float X, float Y, float Z)									//	real constructor
	{
	x = X; y = Y; z = Z;													//	just copy the new values in
	} // end of main Vector constructor

void Vector::PrintToStream()												//	prints to output stream stdout		
	{
	printf("Vector(x:%f, y:%f, z:%f)\n", x, y, z);							//	just dump it out
	} // end of PrintToStream()

Vector &operator *(float &k, Vector &v)										//	scalar left-multiplication
	{
	returnVector.x = k*v.x;													//	copy the components into the return vector
	returnVector.y = k*v.y;
	returnVector.z = k*v.z;
	return returnVector;													//	and return it	
	} // end of scalar multiplication

float operator *(Vector &u, Vector &v)										//	dot product of two vectors 
	{
	return u.x*v.x+u.y*v.y+u.z*v.z;											//	return it
	} // end of dot product

Vector &operator +(Vector &u, Vector &v)									//	addition of two vectors 
	{
	returnVector.x = u.x + v.x;												//	copy the components into the return vector
	returnVector.y = u.y + v.y;				
	returnVector.z = u.z + v.z;				
	return returnVector;													//	and return it
	} // end of dot product

Vector &operator -(Vector &u, Vector &v)									//	subtraction of two homogeneous vectors 
	{
	returnVector.x = u.x - v.x;												//	copy the components into the return vector
	returnVector.y = u.y - v.y;				
	returnVector.z = u.z - v.z;				
	return returnVector;													//	and return it
	} // end of dot product

Vector &operator /(Vector &u, float k)										//	scalar right-division 
	{
	returnVector.x = u.x/k;													//	copy the components into the return vector
	returnVector.y = u.y/k;
	returnVector.z = u.z/k;
	return returnVector;													//	and return it	
	} // end of scalar division
